import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Random;

/**
  *
  * Klasse fr einen intelligenten Computerspieler
  *
  * @version 1.0 vom 10.08.2008
  * @author Daniel Garmann
  */

public class ComputerSpieler extends Spieler {


  private int suchtiefe;
  private int zug;
  private JFrame owner;


  public ComputerSpieler(JFrame owner, int maximaleSuchtiefe)
  {
    this.owner = owner;
    this.suchtiefe = maximaleSuchtiefe;
  }
  
  private int bewertungsfunktion(Position position)
  {
    if (position.augenSumme() < position.zielzahl())
      return 0;
    else
      return -1;
  }


  private int negamax(Position position, int tiefe)
  {
    if (position.spielendeErreicht() || (tiefe <= 1))
      return bewertungsfunktion(position);
    else {
      int wert = -2;
      for (int probezug = 1; probezug <= 6; probezug++) {
        if (position.zulaessig(probezug)) {
          Position folgeposition = position.folgePosition(probezug);
          int folgewert = -negamax(folgeposition, tiefe - 1);
          if (folgewert > wert) {
            wert = folgewert;
            if (tiefe == suchtiefe)
              zug = probezug;
          }
        }
      }
      return wert;
    }
  }
  


  public int spielzugMachen(Position position)
  {
    Random r = new Random();
    int wert = negamax(position,suchtiefe);

    if (wert < 0) {
      do
        zug = r.nextInt(6) + 1;
      while (!position.zulaessig(zug));
    }

    JOptionPane.showConfirmDialog(owner,"Computer dreht auf "+zug,"Computerzug",JOptionPane.OK_CANCEL_OPTION,JOptionPane.INFORMATION_MESSAGE);
    return zug;
  }

}
